#include "ControlOps.h"
#include <stdio.h>

RS_BEGIN_NAMESPACE

/****************************************
 * Operation for binary float addition  *
 ****************************************/

std::vector<opType> OpStringIf::getArgumentTypes()
{
  std::vector<opType> aTypes;
  aTypes.insert(aTypes.begin(), opFloat);
  aTypes.insert(aTypes.begin(), opString);
  aTypes.insert(aTypes.begin(), opString);
  return aTypes;
}

std::string OpStringIf::getString()
{
  if(arguments.size() >= 3)
    {
      if(arguments[0]->getFloat() > 0)
	{
	  return arguments[1]->getString();
	}
      else
	{
	  return arguments[2]->getString();
	}
    }
  return "";
}

std::string OpStringIf::getOperationString()
{
  return "sif";
}

/*******************************************
 * Operation for binary float subtraction  *
 *******************************************/

std::vector<opType> OpFloatIf::getArgumentTypes()
{
  std::vector<opType> aTypes;
  aTypes.insert(aTypes.begin(), opFloat);
  aTypes.insert(aTypes.begin(), opFloat);
  aTypes.insert(aTypes.begin(), opFloat);
  return aTypes;
}

float OpFloatIf::getFloat()
{
  if(arguments.size() >= 3)
    {
      if(arguments[0]->getFloat() > 0)
	{
	  return arguments[1]->getFloat();
	}
      else
	{
	  return arguments[2]->getFloat();
	}
    }
  return 0.0;
}

std::string OpFloatIf::getOperationString()
{
  return "fif";
}

/**********************************************
 * Operation for binary float multiplication  *
 **********************************************/

std::vector<opType> OpPointIf::getArgumentTypes()
{
  std::vector<opType> aTypes;
  aTypes.insert(aTypes.begin(), opFloat);
  aTypes.insert(aTypes.begin(), opPoint);
  aTypes.insert(aTypes.begin(), opPoint);
  return aTypes;
}

Point OpPointIf::getPoint()
{
  if(arguments.size() >= 3)
    {
      if(arguments[0]->getFloat() > 0)
	{
	  return arguments[1]->getPoint();
	}
      else
	{
	  return arguments[2]->getPoint();
	}
    }
  return Point();
}

std::string OpPointIf::getOperationString()
{
  return "pif";
}

RS_END_NAMESPACE









