#ifndef _FLOATMATH_H_
#define _FLOATMATH_H_


#include "Operation.h"

RS_BEGIN_NAMESPACE

/****************************************
 * Operation for binary float addition  *
 ****************************************/
class OpFloatPlus : public FloatOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
   virtual std::vector<opType> getArgumentTypes();
   virtual float getFloat();
protected:
  // Override!
  virtual std::string getOperationString();
};


/*******************************************
 * Operation for binary float subtraction  *
 *******************************************/
class OpFloatMinus : public FloatOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
   virtual std::vector<opType> getArgumentTypes();
   virtual float getFloat();
protected:
  // Override!
  virtual std::string getOperationString();
};

/**********************************************
 * Operation for binary float multiplication  *
 **********************************************/
class OpFloatMultiply : public FloatOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
   virtual std::vector<opType> getArgumentTypes();
   virtual float getFloat();
protected:
  // Override!
  virtual std::string getOperationString();
};

/****************************************
 * Operation for binary float division  *
 ****************************************/
class OpFloatDivide : public FloatOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
   virtual std::vector<opType> getArgumentTypes();
   virtual float getFloat();
protected:
  // Override!
  virtual std::string getOperationString();
};

/****************************************
 * Operation for float constants        *
 ****************************************/
class OpFloatConstant : public FloatOperation {
public:
  OpFloatConstant();
  OpFloatConstant(float val);

  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
  virtual std::vector<opType> getArgumentTypes();
  virtual float getFloat();
protected:
  // Override!
  virtual std::string getOperationString();
private:
  float value;
};

/****************************************
 * Operation for float arguments        *
 ****************************************/
class OpFloatArg : public FloatOperation {
public:
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
  virtual std::vector<opType> getArgumentTypes();
  virtual float getFloat();
 protected:
  // Override!
  virtual std::string getOperationString();
};

RS_END_NAMESPACE

#endif
