/* -*- Mode: C++ -*-
 * $Id: FuzzyScore.h,v 1.2 2001/04/21 12:54:42 sigge Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: FuzzyScore.h
 * Unitname: Framework/skill
 * $Revision: 1.2 $
 * Created by: Fredrik Heintz 1999-xx-xx
 * Last modified by $Author: sigge $ $Date: 2001/04/21 12:54:42 $
 *
 *
 * HISTORY
 * $Log: FuzzyScore.h,v $
 * Revision 1.2  2001/04/21 12:54:42  sigge
 * FuzzyScore now uses NWO (WorldState).
 *
 * Revision 1.1.1.1  2001/04/08 11:33:58  sigge
 * Imported sources
 *
 * Revision 1.2  2000/10/12 02:49:21  marsc818
 * Mostly working although far from perfect FuzzyScore skill
 *
 * Revision 1.1  2000/09/05 21:12:02  frehe
 * #include rs_log.h
 *
 */

/**
 * @file FuzzyScore.h
 * Include file for the skill class FuzzyScore.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: sigge $
 * $Date: 2001/04/21 12:54:42 $
 */


#ifndef FUZZYSCORE_H
#define FUZZYSCORE_H

#include "WorldStateView.h"
#include "ParameterView.h"
#include "MarkerView.h"
#include "KickBallToSpeedVector.h"
#include "Skill.h"


RS_BEGIN_NAMESPACE


/**
 * @class FuzzyScore FuzzyScore.h
 * This class encapsulates a scoring skill.
 *
 * <!--
 * @pre The preconditions for the skill are...
 * @post The postconditions for the skill are...
 * @invariant The class invariant is...
 *
 * @todo This needs to be done...
 * -->
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.2 $
 * $Author: sigge $
 * $Date: 2001/04/21 12:54:42 $
 */
class FuzzyScore : public Skill {
public:
  FuzzyScore();
  virtual ~FuzzyScore();

  virtual Plan generatePlan();

  virtual FuzzyBool persistent();
  virtual FuzzyBool applicable();

protected:
  TVector calculateVector(float& good);

  KickBallToSpeedVector kickSkill;

  ParameterView* parameterView;
  MarkerView* markerView;
  WorldStateView* worldStateView;
};

RS_END_NAMESPACE

#endif // !FUZZYSCORE_H
