#ifndef _OBJMATH_H_
#define _OBJMATH_H_


#include "ViewManager.h"
#include "AgentView.h"
#include "Operation.h"
#include "CoordPoint.h"
#include "AgentView.h"
#include "ParameterView.h"


RS_BEGIN_NAMESPACE

/****************************************
 * Operation for binary Point addition  *
 ****************************************/
class OpAgentPos : public PointOperation {
public:
  OpAgentPos();
  virtual ~OpAgentPos();
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
  virtual std::vector<opType> getArgumentTypes();
  virtual Point getPoint();
protected:
  ViewManager* viewManager;
  ParameterView *parameterView;
  AgentView *agentView;
  
  // Override!
  virtual std::string getOperationString();
};


/*******************************************
 * Operation for binary Point subtraction  *
 *******************************************/
class OpAgentSpeed : public PointOperation {
public:
  OpAgentSpeed();
  virtual ~OpAgentSpeed();
  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
  virtual std::vector<opType> getArgumentTypes();
  virtual Point getPoint();
protected:
  ViewManager* viewManager;
  ParameterView *parameterView;
  AgentView *agentView;
  // Override!
  virtual std::string getOperationString();
};

/*******************************************
 * Operation for binary Point subtraction  *
 *******************************************/

class OpAgentDir : public FloatOperation {
public:
  OpAgentDir();
  virtual ~OpAgentDir();

  virtual Operation* clone() { return cloneOperation(this); }
  // Theese need to be overridden
  virtual std::vector<opType> getArgumentTypes();
  virtual float getFloat();
protected:
  ViewManager* viewManager;
  ParameterView *parameterView;
  AgentView *agentView;
  // Override!
  virtual std::string getOperationString();
};

RS_END_NAMESPACE

#endif
