/* -*- Mode: C++ -*-
 * $Id: Wait.h,v 1.1 2001/04/24 17:10:42 mikbr212 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: Wait.h
 * Unitname: Framework/skill
 * $Revision: 1.1 $
 * Created by: Fredrik Heintz 1999-xx-xx
 * Last modified by $Author: mikbr212 $ $Date: 2001/04/24 17:10:42 $
 *
 *
 * HISTORY
 * $Log: Wait.h,v $
 * Revision 1.1  2001/04/24 17:10:42  mikbr212
 * added
 *
 *
 */

#ifndef WAIT_H
#define WAIT_H


#include "Skill.h"

#include "ParameterView.h"
#include "PassTreeView.h"
#include "GameView.h"
#include "WorldStateView.h"
#include "LookView.h"

#include "MoveToPosition.h"
#include "MarkPlayer.h"
#include "Intercept.h"
#include "Display.h"

#include "rs_log.h"
#include "view_constants.h"


RS_BEGIN_NAMESPACE

/**
 * @class Wait Wait.h
 * This class encapsulates a scoring skill.
 *
 * <!--
 * @pre The preconditions for the skill are...
 * @post The postconditions for the skill are...
 * @invariant The class invariant is...
 *
 * @todo This needs to be done...
 * -->
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.1 $
 * $Author: mikbr212 $
 * $Date: 2001/04/24 17:10:42 $
 */
class Wait : public Skill {
public:
  Wait();
  virtual ~Wait();

  virtual Plan generatePlan();

  virtual FuzzyBool persistent();

  virtual FuzzyBool applicable();

protected:
  Plan turnPlan();
  
  void reset();

  bool wait();
  bool timeToBegin();

  GameView* gameView;
  PassTreeView* passTreeView;
  WorldStateView* worldStateView;
  LookView* lookView;

  int startCycle;
  int maxCycles;
  
  bool hasLotOfTime;

  std::vector<float> teamValues;

private:

};


RS_END_NAMESPACE


#endif // !WAIT_H
