/* -*- Mode: C++ -*-
 * $Id: Intention.cc,v 1.4 2001/07/06 12:53:37 mikbr212 Exp $
 *
 * IDENTIFICATION
 *
 * $Revision: 1.4 $
 * Created by: Mikael Brnnstrm, Andreas Bckert, Andreas Sigfridsson
 * Last modified by $Author: mikbr212 $ $Date: 2001/07/06 12:53:37 $
 *
 *
 * HISTORY
 *
 * $Log: Intention.cc,v $
 * Revision 1.4  2001/07/06 12:53:37  mikbr212
 * Changed utility-methods
 *
 * Revision 1.3  2001/07/06 10:00:22  mikbr212
 * Merged updates and resolved conflicts (a lot)
 *
 * Revision 1.2  2001/07/03 15:25:31  andbo928
 * Added utility methods and enum.
 *
 * Revision 1.1  2001/06/19 14:11:43  mikbr212
 * Created
 *
 */

/**
 * @file Intention.cc
 * Implementation file for the class Intention.
 *
 * @par Unit:
 *      Framework
 * $Revision: 1.4 $
 * $Author: mikbr212 $
 * $Date: 2001/07/06 12:53:37 $
 */


#include "Intention.h"

//  #include "PassTreeView.h"
//  #include "WorldStateView.h"
#include "ParameterView.h"
#include "GameView.h"
//  #include "StatisticsView.h"


RS_BEGIN_NAMESPACE

Intention::Intention()
  : viewManager(ViewManager::instance()),
    parameterView(NULL),
    worldStateView(NULL),
    passTreeView(NULL),
    gameView(NULL),
    statisticsView(NULL)
{
  getView(parameterView, PARAMETER_VIEW_ID);
  getView(worldStateView, WORLD_STATE_VIEW_ID);
  getView(passTreeView, PASS_TREE_VIEW_ID);
  getView(gameView, GAME_VIEW_ID);
  getView(statisticsView, STATISTICS_VIEW_ID);
}

Intention::~Intention() {
  viewManager->releaseView(PARAMETER_VIEW_ID);
  viewManager->releaseView(WORLD_STATE_VIEW_ID);
  viewManager->releaseView(PASS_TREE_VIEW_ID);
  viewManager->releaseView(GAME_VIEW_ID);
  viewManager->releaseView(STATISTICS_VIEW_ID);
}

Plan Intention::generatePlan() {
  return getPlan(false);
}

Plan Intention::getPlan(bool clear) {
  static Skill* chosenSkill(NULL);

  if(clear || 
     !(chosenSkill != NULL &&
       chosenSkill->persistent() &&
       chosenSkill->applicable()))
    chosenSkill = chooseSkill();
  
  if(chosenSkill != NULL)
    return chosenSkill->generatePlan();
  
  return Plan(); // empty plan
}

Skill* Intention::chooseSkill() {
  return NULL;
}

RS_END_NAMESPACE








