/* -*- Mode: C++ -*-
 * $Id: IntentionStub.h,v 1.1 2001/06/19 14:11:43 mikbr212 Exp $
 *
 * IDENTIFICATION
 *
 * $Revision: 1.1 $
 * Created by: Mikael Brnnstrm, Andreas Bckert, Andreas Sigfridsson
 * Last modified by $Author: mikbr212 $ $Date: 2001/06/19 14:11:43 $
 *
 *
 * HISTORY
 *
 * $Log: IntentionStub.h,v $
 * Revision 1.1  2001/06/19 14:11:43  mikbr212
 * Created
 *
 */

/**
 * @file Intention.h
 * Definition file for the class Intention.
 *
 * @par Unit:
 *      Framework
 * $Revision: 1.1 $
 * $Author: mikbr212 $
 * $Date: 2001/06/19 14:11:43 $
 */

#ifndef INTENTION_STUB_H
#define INTENTION_STUB_H

#include "Intention.h"

RS_BEGIN_NAMESPACE

/** 
 * @class IntentionStub IntentionStub.h
 * This class is the abstract base class for all intentions.
 *
 * $Revision: 1.1 $
 * $Author: mikbr212 $
 * $Date: 2001/06/19 14:11:43 $
 */
class IntentionStub : public Intention {
public:
  IntentionStub();
  virtual ~IntentionStub();

  // Uncomment either chooseSkill or generatePlan
  //  virtual Plan generatePlan();
  virtual void model(PlayerState&);

  // Uncomment if the agent should be threated specially
  //    virtual FuzzyBool applicable(); 
  virtual FuzzyBool applicable(const PlayerState&);

  virtual float getPersistence() const;

  virtual IntentionId getID() const;
  
protected:
  // Uncomment either chooseSkill or generatePlan
  //  virtual Skill* chooseSkill();

  // This method should not need to be overloaded
  //  virtual Plan getPlan(bool clear=false);

  // The following method is inherited:
  //  virtual Plan getPlan(bool clear=false);
  
  // The following views are inherited:
  //    ParameterView* parameterView;
  //    WorldStateView* worldStateView;
  //    PassTreeView* passTreeView;
  //    GameView* gameView;
  
private:
  /** Hide copy-constructor. */
  IntentionStub(const IntentionStub&);
  /** Hide assignment operator. */
  IntentionStub& operator= (const IntentionStub&);
};

RS_END_NAMESPACE

/* CONDITIONAL INCLUSION OF INLINE DEFINITIONS
 *
 * If the compiler and debugger understands the keyword inline then include
 * the inline definitions here, otherwise include them in the definition file.
 *
 * This is controlled by a flag called RS_USE_INLINE, which is usually
 * defined. It can be set by the user by giving the compiler an argument
 * usually -DRS_USE_INLINE (to define it) or -URS_USE_INLINE (to undefine it).
 */

#ifdef RS_USE_INLINE
#  include "IntentionStub.icc"
#endif

#endif // INTENTION_STUB_H
