/*
 * $Id: BallState.h,v 1.13 2001/07/29 17:08:31 mikbr212 Exp $
 * 
 * HISTORY 
 *
 * $Log: BallState.h,v $
 * Revision 1.13  2001/07/29 17:08:31  mikbr212
 * Added step(n)
 *
 * Revision 1.12  2001/06/05 20:33:53  mikbr212
 * Fixed doxygen-stubs for all classes
 *
 */

/**
 * @file State.h
 * Definition file for the class State.
 *
 * @par Unit:
 *      Framework/view
 * $Revision: 1.13 $
 * $Author: mikbr212 $
 * $Date: 2001/07/29 17:08:31 $
 */

#ifndef BALLSTATE_H
#define BALLSTATE_H

#include "library_types.h"
#include "ViewManager.h"
#include "ParameterView.h"
#include "view_constants.h"
#include "BallObject.h"
#include "TVector.h"
#include "TLine.h"
#include "State.h"

RS_BEGIN_NAMESPACE

/**
 * @class BallState BallState.h
 * Text...
 */
class BallState : public State
{
public:
  // Nested types.
  
private:
  // Private methods/attributes.
  
protected:
  // Protected methods/attributes.

  TVector speed;
  TVector position;
  TVector kickAcceleration;
  int gameTime;

  // Some uesful views.
  ParameterView* parameterView;

public:
  // Public methods/attributes.

  BallState();
  bool BallState::operator==(const BallState& other) const;

//    virtual void doKick(TVector kick, const PlayerState& kicker);
//    virtual void doNull();

  virtual void init(const BallObject& ballObject);


  void BallState::setAcceleration(const TVector& accVec);
  const TVector& BallState::getAcceleration() const;

  TVector getSpeed() const;
  void setSpeed(const TVector& value);
  TVector getPosition() const;
  void setPosition(const TVector& value);
  int getGameTime() const;
  void setGameTime(int _gameTime);
  double getC() const;
  void setC(double _c);

  bool isHeadedTo(const TVector& pos, 
		  const double margin = 6.0,
		  const unsigned int cycles = 20) const;
  
  void step(int cycles);
  // From State
  virtual void step();
  // Returns number of chars needed.
  virtual string serialize() const;
  // Returns number of chars consumed.
  virtual string deserialize(const string& buf);
};

RS_END_NAMESPACE
#endif // BALLSTATE_H 
