/* -*- Mode: C++ -*-
 * $Id: ConeBlob.cc,v 1.2 2001/06/05 20:33:53 mikbr212 Exp $
 *
 * IDENTIFICATION
 *
 * Filename: TAngle.icc
 * Unitname: Framework/view
 * $Revision: 1.2 $
 * Created by: Mikael Brnnstrm, Andreas Sigfridsson, Andreas Bckert
 * Last modified by $Author: mikbr212 $ $Date: 2001/06/05 20:33:53 $
 *
 *
 * HISTORY
 *
 * $Log:
 *
 *
 */

/**
 * @file ConeBlob.cc
 * Implementation file for the class ConeBlob.
 *
 * $Revision: 1.2 $
 * $Author: mikbr212 $
 * $Date: 2001/06/05 20:33:53 $
 */

#include "ConeBlob.h"

RS_BEGIN_NAMESPACE

ConeBlob::ConeBlob(const float innerRadiusR, const float outerRadiusR,
		   const float innerRadiusTh, const float outerRadiusTh)
  : Blob(2*outerRadiusR, 2*outerRadiusTh),
    innerR(innerRadiusR), outerR(outerRadiusR),
    innerTh(innerRadiusTh), outerTh(outerRadiusTh)
{
  if(innerR < 0)
    innerR = 0;
  if(outerR < innerR)
    outerR = innerR;
  if(innerTh < 0)
    innerTh = 0;
  if(outerTh < innerTh)
    outerTh = innerTh;
}

ConeBlob::~ConeBlob()
{
}

float ConeBlob::getValueAt(float rDepth, float angle /*Vector v*/)
{
//   float rDepth, angle;
//   rDepth = v.getLength();
//   angle = v.getAngle().getDeg();
//   if(angle < 0.0)
//   {
//     rDepth = -rDepth;
//     angle += 180.0;
//   }
  float iradius = pow(rDepth/innerR, 2) + pow(angle/innerTh, 2);
  float oradius = pow(rDepth/outerR, 2) + pow(angle/outerTh, 2);
  if (iradius < 1.0)
    return 1.0;
  else
    return max(1.0 - sqrt(oradius), 0.0);
}

RS_END_NAMESPACE
