/* -*- Mode: C++ -*-
 * $Id: ConeBlob.h,v 1.2 2001/06/05 20:33:53 mikbr212 Exp $
 *
 * IDENTIFICATION
 *
 * Filename: TAngle.icc
 * Unitname: Framework/view
 * $Revision: 1.2 $
 * Created by: Mikael Brnnstrm, Andreas Sigfridsson, Andreas Bckert
 * Last modified by $Author: mikbr212 $ $Date: 2001/06/05 20:33:53 $
 *
 *
 * HISTORY
 *
 * $Log:
 *
 *
 */

/**
 * @file ConeBlob.cc
 * Definition file for the class ConeBlob.
 *
 * $Revision: 1.2 $
 * $Author: mikbr212 $
 * $Date: 2001/06/05 20:33:53 $
 */

#include "TerritoryControlView.h" // Blob

#ifndef CONEBLOB_H
#define CONEBLOB_H

RS_BEGIN_NAMESPACE

/**
 * @class ConeBlob ConeBlob.h
 * The cone looks like a fez (turkish hat) where the innerRadius
 * is the top and the outerRadius is the bottom. outerRadius
 * must of course be larger than (or equal to, to create a cylinder)
 * than the innerRadius. To get an ordinary cone choose innerRadius
 * to zero.
 */

class ConeBlob : public Blob {
public:
  ConeBlob(const float innerRadiusR, const float outerRadiusR,
	   const float innerRadiusTh, const float outerRadiusTh);
  ~ConeBlob();
  float getValueAt(float rDepth, float angle);

private:
  float innerR;
  float outerR;
  float innerTh;
  float outerTh;
};

RS_END_NAMESPACE

#endif // CONEBLOB_H
