/* -*- Mode: C++ -*-
 * $Id: Message.h,v 1.4 2001/07/26 12:21:07 mikbr212 Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: Message.h
 * Unitname: Framework/view
 * $Revision: 1.4 $
 * Created by: Fredrik Heintz 2000-09-12
 * Last modified by $Author: mikbr212 $ $Date: 2001/07/26 12:21:07 $
 *
 *
 * HISTORY
 *
 * $Log: Message.h,v $
 * Revision 1.4  2001/07/26 12:21:07  mikbr212
 * Added passways
 *
 * Revision 1.3  2001/04/23 22:55:08  mikbr212
 * Added MarkMessageType
 *
 * Revision 1.2  2001/04/13 16:26:20  sigge
 * Added worldStateMessageType
 *
 * Revision 1.1  2001/04/12 13:38:18  sigge
 * Added CommunicationView
 *
 *
 */

/**
 * @file Message.h
 * Include file for the view class Message.
 *
 * @par Unit:
 *      Framework/view
 * $Revision: 1.4 $
 * $Author: mikbr212 $
 * $Date: 2001/07/26 12:21:07 $
 */


#ifndef MESSAGE_H
#define MESSAGE_H

RS_BEGIN_NAMESPACE

// Message types (0 is reserved)
const int worldStateMessageType = 1;
const int markPlayerMessageType = 2;
const int passWaysMessageType = 3;

/**
 * @class Message Message.h
 *
 * @par Unit:
 *      Framework/view
 * $Revision: 1.4 $
 * $Author: mikbr212 $
 * $Date: 2001/07/26 12:21:07 $
 */
class Message {
public:
  /** Construct a message with the Type @a id and the contents
    @a contents. */
  Message(const int type, const string contents);
  Message(string& _rawContents);

  ~Message();

  int getType() const;
  string getContents() const;
  string serialize() const;

protected:
  int type;
  string contents;

private:
};


RS_END_NAMESPACE


#endif // !MESSAGE_H
