/*
 * $Id: State.h,v 1.4 2001/06/05 20:33:53 mikbr212 Exp $
 * 
 * HISTORY 
 *
 * $Log: State.h,v $
 * Revision 1.4  2001/06/05 20:33:53  mikbr212
 * Fixed doxygen-stubs for all classes
 *
 */

/**
 * @file State.h
 * Definition file for the class State.
 *
 * @par Unit:
 *      Framework/view
 * $Revision: 1.4 $
 * $Author: mikbr212 $
 * $Date: 2001/06/05 20:33:53 $
 */

#ifndef STATE_H
#define STATE_H

#include "machine_dependent_compiler_directives.h"
#include <iostream>
#include <string>

RS_BEGIN_NAMESPACE


template<class T> 
string asString(const T& data)
{
  return string((char*) &data, sizeof(T));
}

template<class T>
T fromString(T, const string& str)
{
  T d;
  memcpy(&d, str.data(), sizeof(T));
  return d;
}

template<class T>
string skipString(T, const string& str)
{
  return str.substr(sizeof(T));
}

/**
 * @class State State.h
 * Text...
 */

class State
{
public:
  // Nested types.
  
private:
  // Private methods/attributes.
  
protected:
  // Protected methods/attributes.

  

public:
  // Public methods/attributes.
  virtual void step() = 0;
  // Returns number of chars needed.
  virtual string serialize() const = 0;
  // Returns number of chars consumed.
  virtual string deserialize(const string& buf) = 0;
};

RS_END_NAMESPACE
#endif /* WORLDSTATE_H */
