package robosoc;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.image.*;
import java.awt.event.*;

public class StatusView extends JPanel {

    public static class ParseErrorException extends RuntimeException {
	private String str;
	public ParseErrorException(String s) {
	    str = s;
	}
	
	public String toString() {
	    return "ParseErrorException: "+str;
	}
    }

    JProgressBar stamina;
    JLabel uniformNo;

    public StatusView() {
	stamina = new JProgressBar(0,3500);
	stamina.setString("<unknown>");
	stamina.setStringPainted(true);
	uniformNo = new JLabel("<unknown>");
	
	// Add stuff
	setLayout(new GridBagLayout());
	GridBagConstraints c1 = new GridBagConstraints();
	GridBagConstraints c2 = new GridBagConstraints();
	c1.insets = new Insets(5,10,5,0); // Left
	c1.weightx = 1;
	c1.gridwidth = 1;
	c1.fill = GridBagConstraints.NONE;
	c1.anchor = GridBagConstraints.WEST;

	c2.insets = new Insets(5,10,5,0); // Right
	c2.weightx = 1;
	c2.gridwidth = GridBagConstraints.REMAINDER;
	c2.fill = GridBagConstraints.NONE;
	c2.anchor = GridBagConstraints.WEST;
	
	add(new JLabel("Uniform number:"),c1);
	add(uniformNo,c1);
	add(new JLabel("Stamina:"),c1);
	add(stamina,c2);
    }
    
    public void setStatus(java.util.List list) {
	if(list.size() != 3)
	    throw new ParseErrorException("Wrong size of list: "+list);
	
	if(!list.get(0).equals("status"))
	    throw new ParseErrorException("Can't recognize first argument: "+list);
	try {
	    uniformNo.setText((String)list.get(1));
	    stamina.setValue(Integer.parseInt((String)list.get(2)));
	    stamina.setString((String)list.get(2));
	} catch(NumberFormatException nfe) {
	    throw new ParseErrorException(nfe.toString());
	}
    }
}
